#!/usr/bin/python

import time, sys, os, atexit, code
import readline, rlcompleter

sys.path.append("pdu-python-api")
import raritan.rpc
from raritan.rpc import Agent
from raritan.rpc import net, firmware, cfg, session, event
from raritan.rpc import pdumodel, tfw, test

def parse_url(url):
	scheme = 'https'
	username = 'admin'
	password = 'raritan'
	hostname = url

	parts = hostname.split('://')
	if len(parts) >= 2:
		(scheme, hostname) = parts

	parts = hostname.split('@')
	if len(parts) >= 2:
		(username, hostname) = parts

	parts = username.split(':')
	if len(parts) >= 2:
		(username, password) = parts

	return (scheme, hostname, username, password)

try:
	(scheme, hostname, username, password) = parse_url(sys.argv[1])
except Exception:
	print("Usage: px2_shell.py [scheme://][user[:password]@]host")
	sys.exit(1)

readline.parse_and_bind('tab: complete')

history = os.path.join(os.environ["HOME"], ".px2_shell_history")
try:
	readline.read_history_file(history)
except IOError:
	pass

atexit.register(readline.write_history_file, history)

agent = Agent(scheme, hostname, username, password, debug = False)

# selected sysrpc proxies
net_proxy = net.Net("/net", agent)
firmware_proxy = firmware.Firmware("/firmware", agent)
cfg_proxy = cfg.Cfg("/cfg", agent)
session_manager = session.SessionManager("/session", agent)
event_engine = event.Engine("/event_engine", agent)

# selected modelrpc proxies
core = tfw.CoreCtrl("/model/core", agent)
unit = pdumodel.Unit("/model/unit", agent)
pdu = pdumodel.Pdu("/model/pdu/0", agent)
inlets = pdu.getInlets()
ocps = pdu.getOverCurrentProtectors()
outlets = pdu.getOutlets()

code.interact(local=globals())
